/*
 * Copyright 2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

defaultTasks 'dists'

allprojects {
    task clean {
        description = "Deletes the build directory ($buildDir.name)"
        group = 'build'
    }
}

task libs {
    dependsOn { subprojects*.libs }
    description = 'Builds the JAR'
}

task dists {
    dependsOn libs
    description = 'Builds the distribution'
    group = 'build'
}

subprojects {
    configurations {
        compile
    }
    repositories {
        mavenCentral()
    }
    dependencies {
        if (project.name == 'webapp') {
        	compile "commons-io:commons-io:1.2"
		} else {
			compile "junit:junit:4.7"
		}
    }
    task libs {
        if (project.name == 'webapp') {
            dependsOn ':api:libs' 
        }
        description = 'Builds the JAR'
        group = 'build'
    }
    tasks.addRule(new TestRule())
}

class TestRule implements Rule {
    public String getDescription() {
        'build<ConfigurationName>: builds the artifacts of the given configuration'
    }

    public void apply(String taskName) {
    }
}
